'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterRows = exports.selectRow = undefined;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reselect = require('reselect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * DEPRECATED
 *
 * Select one or severals rows from `selector` if the key `key` is equal to
 * `value`.
 *
 * @param  {Function}         Selector function (`createSelector` from reselect)
 * @param  {String}           Key
 * @param  {String | Number}  Value
 * @return {Function}         Selector
 */
/* eslint no-console: 0 */

var selectRow = exports.selectRow = function selectRow(selector, key, value) {
  console.info('\n`selectRow` is deprecated. Please use `filterRows` instead.\nNotice that `filterRows` doesn\'t call the selector by default, like \\createSelector` from `reselect` does.\n');

  if (_lodash2.default.isUndefined(selector) || _lodash2.default.isUndefined(key) || _lodash2.default.isUndefined(value)) {
    return function () {
      return 'Bad arguments for `selectRow`';
    };
  }

  return (0, _reselect.createSelector)(selector(), function (rows) {
    var result = _lodash2.default.groupBy(rows, key)[value];
    if (_lodash2.default.isArray(result) && result.length === 1) {
      result = result.pop();
    }
    return result;
  });
};

/**
 * Filter row(s) from `selector` where the value of `key` is equal to `value`.
 *
 * @param  {Function}         Selector function (`createSelector` from reselect)
 * @param  {String}           Key
 * @param  {String | Number}  Value
 * @param  {Type}             Type of the output
 *                            (if undefined, return an array or an object)
 * @return {Function}         Selector
 */
var filterRows = exports.filterRows = function filterRows(selector, key, value, outputType) {
  if (!_lodash2.default.isFunction(selector)) {
    throw new Error('`selector` should be a function.');
  }

  if (!_lodash2.default.isString(key)) {
    throw new Error('`key` should be a string.');
  }

  if (_lodash2.default.isUndefined(key)) {
    throw new Error('`value` should be defined.');
  }

  return (0, _reselect.createSelector)(selector, function (rows) {
    var result = _lodash2.default.groupBy(rows, key)[value];

    if (_lodash2.default.isArray(result) && result.length === 1 && outputType !== Array) {
      result = result.pop();
    }

    return result;
  });
};